function y=lagrange(u);


% ************************************************
% Le vecteur d'entre u est  9 composantes
%
%	u(1)=p    rotation absolue satellite sur x
%	u(2)=q    ...........................sur y
%	u(3)=r    ...........................sur z
%
%	u(4)=q0   Premire composante du quaternion
%	u(5)=q1   Deuxime ........................
%	u(6)=q2   Troisime .......................
%	u(7)=q3   Quatrime .......................
%
% Les donnes inertielles
%	u(8)=A   Inertie transverse    
%	u(9)=C  ....... axiale
%
%
% Dans le bloc diagramme nous multiplexerons ces entres
%  7+2=9
%
% ******************************************************

p=u(1);q=u(2);r=u(3);
% normalisation du quaternion d'entre
v=u(4:7)/norm(u(4:7));
q0=v(1);q1=v(2);q2=v(3);q3=v(4);
A=u(8);C=u(9);


y=[];

% Calcul des drives de p q r

y(1)=(C-A)/A*(-q*r);
y(2)=(A-C)/A*(-p*r);
y(3)=0;

% Matrice W* associe  la rotation en temps que quaternion

Matrice_rotation=[0 -p -q -r
                 p 0 r -q
		 q -r 0 p
		 r q -p 0];

z=0.5*Matrice_rotation*[q0 q1 q2 q3]';


y=[y z']';

end
