clear
clc

% Ce fichier initialise la simulation SCAOqtn6.m

% Inerties satellite en kg-m

A=180;
A=180;
C=250;


M=50;g=10;d=0.2;Mgd=M*g*d;

% ******* INITIALISATION AVEC ANGLES D'EULER**************
% Initialisation en vitesses angulaires absolues (rd/s)

v_psi0=0;
v_teta0=0;
v_phi0=pi/20;

% Initialisation en position (rd)

psi0=pi/2;
teta0=pi/6;
phi0=-pi/2;

% ****** CALCULS D'INITIALISATION DU VECTEUR D'ETAT ********

vp0=v_psi0*sin(teta0)*sin(phi0)+v_teta0*cos(phi0);

vq0=psi0*sin(teta0)*cos(phi0)-v_teta0*sin(phi0);

vr0=v_phi0+v_psi0*cos(teta0);
   

% ---- Calcul du quaternion initial connaissant les angles initoaux

% Matrice de passage P de la base fixe  la base satellite
%  l'instant initial

Pmat(1,1)=-sin(psi0)*sin(phi0)*cos(teta0)+cos(phi0)*cos(psi0);
Pmat(1,2)=-sin(psi0)*cos(phi0)*cos(teta0)-sin(phi0)*cos(psi0);
Pmat(1,3)=sin(teta0)*sin(psi0);

Pmat(2,1)=cos(psi0)*sin(phi0)*cos(teta0)+cos(phi0)*sin(psi0);
Pmat(2,2)=cos(psi0)*cos(phi0)*cos(teta0)-sin(phi0)*sin(psi0);
Pmat(2,3)=-sin(teta0)*cos(psi0);

Pmat(3,1)=sin(teta0)*sin(phi0);
Pmat(3,2)=sin(teta0)*cos(phi0);
Pmat(3,3)=cos(teta0);

% Calcul du quaternion initial
%
% Nous prenons toujours q0 >0 ou nul

trac=trace(Pmat);

qt00=(1+trac)^0.5/2;

qt10=(1-trac+2*Pmat(1,1))^0.5/2;

qt20=(1-trac+2*Pmat(2,2))^0.5/2;

qt30=(1-trac+2*Pmat(3,3))^0.5/2;

if abs(qt00)>1e-8, 
qt10=qt10*sign((Pmat(3,2)-Pmat(2,3))/4/qt00);
qt20=qt20*sign((Pmat(1,3)-Pmat(3,1))/4/qt00);
qt30=qt30*sign((-Pmat(1,2)+Pmat(2,1))/4/qt00);


elseif abs(qt10)>1e-8, 

qt20=qt20*sign((Pmat(1,2)+Pmat(2,1))/4/qt10);
qt30=qt30*sign((Pmat(1,3)+Pmat(3,1))/4/qt10);
qt00=qt00*sign((Pmat(3,2)-Pmat(2,3))/4/qt10);


elseif abs(qt20)>1e-8, 

qt10=qt10*sign((Pmat(1,2)+Pmat(2,1))/4/qt20);
qt30=qt30*sign((Pmat(2,3)+Pmat(3,2))/4/qt20);
qt00=qt00*sign((Pmat(1,3)-Pmat(3,1))/4/qt20);


elseif abs(qt30)>1e-8,
 
qt20=qt20*sign((Pmat(3,2)+Pmat(2,3))/4/qt30);
qt10=qt10*sign((Pmat(1,3)+Pmat(3,1))/4/qt30);
qt00=qt00*sign((-Pmat(1,2)+Pmat(2,1))/4/qt30);

end
Q=[qt00 qt10 qt20 qt30]/norm([qt00 qt10 qt20 qt30]);

etat_init=[vp0 vq0 vr0 qt00 qt10 qt20 qt30];

end










